#include <bits/stdc++.h>
#pragma GCC optimize("O2")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

using namespace std;

const int maxn = 200005;

int n, m;

int flags[maxn];
vector<int> g[maxn];

pair<int, int> to_sort[maxn];

bool answer[maxn];

long long comp_sum[maxn];
vector<int> comps[maxn];

int parent[maxn];

int root(int node)
{
    if (node == parent[node])
    {
        return node;
    }

    return parent[node] = root(parent[node]);
}

void connect(int x, int y)
{
    x = root(x);
    y = root(y);

    comp_sum[x] += comp_sum[y];
    parent[y] = x;

    for (int i = 0; i < comps[y].size(); ++i)
    {
        comps[x].push_back(comps[y][i]);
    }
}

bool is_connected(int x, int y)
{
    return root(x) == root(y);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        cin >> flags[i];
        to_sort[i] = make_pair(flags[i], i);
    }

    sort(to_sort + 1, to_sort + n + 1);

    for (int i = 1; i <= m; ++i)
    {
        int x, y;
        cin >> x >> y;

        g[x].push_back(y);
        g[y].push_back(x);
    }

    for (int i = 1; i <= n; ++i)
    {
        sort(g[i].begin(), g[i].end(), [](int x, int y)
        {
            return flags[x] <= flags[y];
        });
    }

    for (int i = 1; i <= n; ++i)
    {
        answer[i] = true;
        parent[i] = i;
        comp_sum[i] = flags[i];
        comps[i].push_back(i);
    }

    for (int i = 1; i <= n; ++i)
    {
        int node = to_sort[i].second;

        for (int j = 0; j < g[node].size(); ++j)
        {
            int next_node = g[node][j];

            if (flags[node] < flags[next_node])
            {
                continue;
            }

            int comp_root = root(next_node);

            if (comp_sum[comp_root] < flags[node])
            {
                for (int k = 0; k < comps[comp_root].size(); ++k)
                {
                    answer[comps[comp_root][k]] = false;
                }
            }

            if (is_connected(node, comp_root) == false)
            {
                connect(node, comp_root);
            }
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        cout << answer[i];
    }

    cout << endl;

    return 0;
}
