#include <bits/stdc++.h>

using namespace std;

const int maxn = 2005;

int n;

vector<int> g[maxn];
int weights[maxn][maxn];

int parent[maxn];

void dfs1(int node, int par)
{
    parent[node] = par;

    for (int i = 0; i < g[node].size(); ++i)
    {
        if (g[node][i] != par)
        {
            dfs1(g[node][i], node);
        }
    }
}

long long dist[maxn];

void calc(int node, int par, long long up)
{
    dist[node] = up;

    for (int i = 0; i < g[node].size(); ++i)
    {
        if (g[node][i] != par)
        {
            calc(g[node][i], node, up + weights[node][g[node][i]]);
        }
    }
}

void clear_path(int node)
{
    while (parent[node] != -1)
    {
        weights[node][parent[node]] = 0;
        weights[parent[node]][node] = 0;
        node = parent[node];
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back(y);
        g[y].push_back(x);

        weights[x][y] = w;
        weights[y][x] = w;
    }

    dfs1(1, -1);

    long long first = 0;
    long long second = 0;

    for (int i = 1; i <= n; ++i)
    {
        calc(1, -1, 0);

        int idx = 1;
        long long max_score = 0;

        for (int j = 1; j <= n; ++j)
        {
            if (max_score < dist[j])
            {
                max_score = dist[j];
                idx = j;
            }
        }

        if (i % 2 == 1)
        {
            first += max_score;
        }
        else
        {
            second += max_score;
        }

        clear_path(idx);
    }

    if (first > second)
    {
        cout << "Irma " << first << endl;
    }
    else if (first == second)
    {
        cout << "Draw" << endl;
    }
    else
    {
        cout << "Alex " << second << endl;
    }

    return 0;
}
