#include <algorithm>
#include <iostream>
#include <cassert>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 1000000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int a[MAXN], n;
bool taken[MAXN];

void solve()
{
    if (n == 1)
    {
        std::cout << 0 << '\n';
        return;
    }

    if (n == 2)
    {
        std::cout << (a[1] != a[2]) << '\n';
        return;
    }

    int ans = 0;
    int l = 1, r = n;
    int addL = 1, addR = n;

    while (l < r)
    {
        taken[l] = taken[r] = 1;
        if (a[l] == a[r])
        {
            while (taken[l]) ++l;
            while (taken[r]) --r;
            continue;
        }

        ans++;
        while (taken[addL]) ++addL;
        while (taken[addR]) --addR;
        
        if (addL > addR) break;
        assert(1 <= addL && addL <= n);
        assert(1 <= addR && addR <= n);
        
        if (a[l] < a[r])
        {
            a[l] += a[addL];
            taken[addL] = 1;
        } else
        {
            a[r] += a[addR];
            taken[addR] = 1;
        }
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}