#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 1000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, q;
int a[MAXN][MAXN];

void makeShift(const std::vector <std::pair <int,int>> &v, int k)
{
    std::vector <int> newVals;
    for (int i = (int)v.size() - 1 ; i >= (int)v.size() - k ; --i)
    {
        newVals.push_back(a[v[i].first][v[i].second]);
    }

    std::reverse(newVals.begin(), newVals.end());
    for (int i = 0 ; i < v.size() - k ; ++i)
    {
        newVals.push_back(a[v[i].first][v[i].second]);
    }

    int ptr = 0;
    for (const auto &[row, col] : v)
    {
        a[row][col] = newVals[ptr++];
    }
}

std::vector <std::pair <int,int>> v;
void solve()
{
    for (int i = 0 ; i < n ; ++i)
    {
        std::iota(a[i], a[i] + n, i * n + 1);
    }

    char qType;
    int row, col;
    int k;

    for (int i = 1 ; i <= q ; ++i)
    {
        v.clear();
        std::cin >> qType;
        if (qType == 'r')
        {
            std::cin >> row >> k;
            for (int col = 0 ; col < n ; ++col)
            {
                v.push_back({row, col});
            }
        } else if (qType == 'c')
        {
            std::cin >> col >> k;
            for (int row = 0 ; row < n ; ++row)
            {
                v.push_back({row, col});
            }
        } else if (qType == 'd')
        {
            std::cin >> row >> col >> k;
            int min = std::min(row, col);
            row -= min;
            col -= min;

            int lastRow = row + n - std::max(row, col) - 1;
            int lastCol = col + n - std::max(row, col) - 1;
       
            while (row <= lastRow)
            {
                v.push_back({row, col});
                row++; col++;
            }
        } else if (qType == 'x')
        {
            std::cin >> row >> col >> k;
            int min = std::min(row, n - col - 1);
            row -= min;
            col += min;

            int maxAdd = std::min(n - row - 1, col);
            int lastRow = row + maxAdd;
            int lastCol = col - maxAdd;
       
            while (row <= lastRow)
            {
                v.push_back({row, col});
                row++; col--; 
            }
        } else
        {
            assert(false);
        }    

        if (k < 0)
        {
            std::reverse(v.begin(), v.end());
            k = -k;
        }

        k %= v.size();
        if (k == 0)
        {
            continue;
        }

        makeShift(v, k);
    }

    std::cin >> q;
    for (int i = 1 ; i <= q ; ++i)
    {
        int r, c;
        std::cin >> r >> c;
        std::cout << a[r][c] << '\n';
    }
}

void input()
{
    std::cin >> n >> q;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}